const mongoose = require("mongoose");
const SettingModel = require("../models/Settings");
const UserModel = require("../models/Users");
const FinalclientModel = require("../models/Finalclients");
const ChatModel = require("../models/Chats");
const MessageModel = require("../models/Messages");

exports.createChat = async function (req, res) {
    if(!req.body.roomId || !req.body.userId || !req.body.chatUserId) {
        return res.status(200).json({ status_code: 400, message: "Invalid Params" });
    } else {
        try {
            let chatCount = await ChatModel.countDocuments({ roomId: req.body.roomId });
            if (chatCount === 0) {
                let newChat = new ChatModel({
                    roomId: req.body.roomId,
                    userId: req.body.userId,
                    chatUserId: req.body.chatUserId, 
                    lastMessage: req.body.lastmessage
                });
                newChat.save().then(async (chatDetails) => {
                    let eachChat = await ChatModel.findById(chatDetails._id);

                    let chats = {
                        status_code: 200,
                        roomId: eachChat.roomId,
                        userId: eachChat.userId,
                        chatUserId: eachChat.chatUserId,
                        message: eachChat.lastMessage,
                        date: eachChat.updatedAt
                    };
                    return res.status(200).json(chats);
                }).catch((error) => {
                    console.log('Error saving chat:', error);
                    return res.status(500).json({ status_code: 500, error: 'Internal server error' });
                });
            } else {
                let userChats = await ChatModel.findOne({ roomId: req.body.roomId });
                let chats = {
                    status_code: 200,
                    roomId: userChats.roomId,
                    userId: userChats.userId,
                    chatUserId: userChats.chatUserId
                };
                return res.status(200).json(chats);
            }
        } catch (error) {
            console.log("Err: ", error);   
        }
    }
};

exports.getChat = async function (req, res) {
    if(!req.body.userId) {
        return res.status(200).json({ status_code: 400, message: "Invalid Params" });
    } else {
        // let chatUserIds = [];
        let allchatData = await ChatModel.find({ userId: req.body.userId });
        const chatUserIds = allchatData.map(chat => String(chat.chatUserId));
        // if(allchatData) {
        //     allchatData.forEach(eachChat => {
        //         chatUserIds.push(String(eachChat.chatUserId));
        //     });
        // }
        return res.status(200).json({ status_code: 200, chats: chatUserIds });
    }
};

exports.getChatHistory = async function (req, res) {
    if(!req.body.roomId) {
        return res.status(200).json({ status_code: 400, message: "Invalid Params" });
    } else {
        let msgArray = [];
        let allMsgData = await MessageModel.find({ roomId: req.body.roomId });
        if(allMsgData) {
            allMsgData.forEach(eachMsg => {
                msgArray.push(eachMsg);
            });
        }
        return res.status(200).json({ status_code: 200, chats: msgArray });
    }
};