const UserModel = require("../models/Users");
const subscriptionModel = require("../models/Subscriptions");
const SettingModel = require("../models/Settings");
const Stripe = require('stripe');
const mongoose = require("mongoose");
const { DateTime } = require("luxon");

exports.subscriptionPayment = async function (req, res) {  
  let Settings = await SettingModel.findOne();
  let amount = Settings.subsciption_price;
  let user_id = req.body.user_id;
  let user_email = req.body.user_email;
  let currency_code = req.body.currency_code;
  let company_name = encodeURIComponent(req.body.company_name); 

  try {
    const stripe = Stripe('sk_test_51JUnIwByHL8wRwOFHVSjjUAIegcHzDPehFZRk9yi2jYWIevzKjIVrSRiWh95VlkY8f87vHEhHYbefnwcuGmFDixb00WB3guxFE');
    const session = await stripe.checkout.sessions.create({
      payment_method_types: ['card'],
      mode: 'payment',
      line_items: [{
        price_data: {
          product_data: {
            name: 'Subscription payment'
          },
          currency: currency_code,
          unit_amount: amount * 100,
        },
        quantity: 1,
      }],
      metadata: {
        user_id: user_id,
        user_email: user_email,
        company_name: company_name,
        amount: amount
      },
      success_url: `http://68.183.80.168/pwa/${company_name}/after-login/subscription/active`,
      cancel_url: `http://68.183.80.168/pwa/${company_name}/after-login`,
      locale: 'en',
    });

    return res.status(200).json({
      status: "true",
      message: "Payment link generated successfully",
      url: session.url,
      id: session.id
    });
  } catch (error) {
    console.log("subscriptionPayment Err: ", error);
  }
};

exports.subscriptionWebhook = async function (req, res) {
  let Settings = await SettingModel.findOne();
  const stripe = Stripe('sk_test_51JUnIwByHL8wRwOFHVSjjUAIegcHzDPehFZRk9yi2jYWIevzKjIVrSRiWh95VlkY8f87vHEhHYbefnwcuGmFDixb00WB3guxFE');
  const sig = req.headers['stripe-signature'];
  const stripe_webhook_secret = 'whsec_Gt938861RbOBDUv2Mq0gOVOZWdcFxlQO';

  let event;
  try {
    event = stripe.webhooks.constructEvent(req.body, sig, stripe_webhook_secret);
  } catch (err) {
    console.error("Webhook signature verification failed: ", err.message);
    // return res.status(400).send(`Webhook Error: ${err.message}`);
  }

  if (event.type === "checkout.session.completed") {
    const session = event.data.object;
    if(session != '') {
      let subscribepaymentData = {
        userId: session.metadata.user_id,
        userEmail: session.metadata.user_email,
        companyName: session.metadata.company_name,
        transactionId: session.payment_intent,
        amount: session.metadata.amount,
        duration: "Monthly",
        payment_method: "Stripe",
        status: "active",
        created_at: Date.now(),
      };
      let subscribepayment = new subscriptionModel(subscribepaymentData);
      try {
        await subscribepayment.save();
        
        const nowIST = DateTime.now().setZone("Asia/Kolkata");
        let userDetails = await UserModel.findById(session.metadata.user_id);
        userDetails.subscription = 1;
        userDetails.subscription_end = Math.floor(nowIST.plus({ days: 5 }).toSeconds());
        try {
          await userDetails.save();
        } catch (error) {
          console.log("Error saving user details: ", error);  
        }
      } catch (error) {
        console.log("Error saving payment details: ", error);
      }
    }
    return res.status(200).json({ received: true });
  }
};

exports.allSubscriptions = async function (req, res) {
  let user_id = req.body.user_id;
  let limit = parseInt(req.body.limit) || 0;
  let offset = parseInt(req.body.offset) || 0;

  let allSubscriptions = await subscriptionModel.find({userId: user_id, status: "active"}).limit(limit).skip(offset);
  
  return res.status(200).json({ 
    status: "true",
    subscriptions: allSubscriptions
  });
};