const express = require("express");
const mongoose = require("mongoose");
const cors = require("cors");
const dotenv = require("dotenv");
const http = require("http");
const { Server } = require("socket.io");

dotenv.config();

const app = express();
app.use(cors());
// app.use(express.json());
app.use((req, res, next) => {
  if (req.originalUrl === '/subscriptionwebhook') {
    express.raw({ type: 'application/json' })(req, res, next);  // For webhook route: use raw body parser with 'application/json' content type
  } else {
    express.json()(req, res, next); // For all other routes: use JSON parser  
  }
});

let adminRoutes = require("./routes/adminRoutes");
let businessownerRoute = require("./routes/businessownerRoutes");
let finalclientRoute = require("./routes/finalclientRoutes");

app.use("/admin", adminRoutes);
app.use("/", businessownerRoute);
app.use("/finalclient", finalclientRoute);

mongoose
  .connect(process.env.MONGO_URI)
  .then(() => console.error("Database Connected Successfully"))
  .catch((err) => console.error(err));

const server = http.createServer(app);

// const io = new Server(server,{
//   cors:{
//     origin: "http://localhost:3000",
//     methods: ["GET", "POST"],
//   },
// })

// io.on("connection", (socket) => {
//   console.log(`User Connected: ${socket.id}`);

//   socket.on("join_room", (data) => {
//     socket.join(data);
//     console.log(`User with ID: ${socket.id} joined room: ${data}`);
//   });

//   socket.on("send_message", (data) => {
//     socket.to(data.room).emit("receive_message", data);
//   });

//   socket.on("disconnect", () => {
//     console.log("User Disconnected", socket.id);
//   });
// });

server.listen(3000, () => {});


