const mongoose = require("mongoose");
const Schema = mongoose.Schema;

let EmployeesSchema = new Schema({
  name: {
    type: String,
  },
  business_owner: {
    type: mongoose.Schema.Types.ObjectId,
    ref: "Users",
  },
  company_name: {
    type: String,
  },
  email: {
    type: String,
  },
  phone_number: {
    type: String,
  },
  status: {
    type: Number, // 0 - disable, 1 - active
    default: 1,
  }, 
  booking_count: {
    type: Number,
    default:0
  },
  deleted_at: {
    type: String,
    default: null
  },
});

module.exports = mongoose.model("Employee", EmployeesSchema);
