const mongoose = require("mongoose");
const Schema = mongoose.Schema;

let ReservationsSchema = new Schema({
    final_client: {
       type: mongoose.Schema.Types.ObjectId,
        ref: 'Finalclient'
    },
    business_owner: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'User'
    },
    employee: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'Employee'
    },
    booking_date: {
        type : String
    },
    start_time: {
        type : String
    },
    end_time: {
        type : String
    },
    start_time24: {
        type : String
    },
    end_time24: {
        type : String
    },
    reservation_date: {
        type : String
    },
    amount: {
        type : Number
    },
    status: {
        type : String // Pending, Accepted, Completed, Cancelled, Expired
        /*
            Pending - Manual Booking
            Accepted - Automatic Booking
            Completed - Booking Completed
            Cancelled - Booking Cancelled by business owner
            Expired - Booking time has expired
        */
    },
    reason: {
        type : String
    },
    cancelled_by:{
        type : String
    },
    
});

module.exports = mongoose.model("Reservation", ReservationsSchema);
