const mongoose = require("mongoose");
const { type } = require("os");
const Schema = mongoose.Schema;

let SubscriptionSchema = new Schema({
    userId: {
        type: String
    },
    userEmail: {
        type: String
    },
    business_owner: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'User'
    },
    companyName: {
        type: String
    },
    transactionId: {
        type: String  
    },
    amount: {
        type: String
    },
    duration: {
        type: String
    },
    payment_method: {
        type: String
    },
    status: {
        type: String
    },
    created_at: {
        type: String
    }
}, { timestamps: true });

module.exports = mongoose.model("Subscription", SubscriptionSchema);

