const mongoose = require("mongoose");
const Schema = mongoose.Schema;

let UsersSchema = new Schema({
    name: {
        type: String
    },
    username: {
        type: String,
        required: true,
        unique: true 
    },
    age: {
        type: String
    },
    company_name: {
        type: String
    },
    company_name_display : {
        type: String
    },
    address: {
        type: String
    },
    address1: {
        type: String
    },
    address2: {
        type: String
    },
    city: {
        type: String
    },
    state: {
        type: String
    },
    country: {
        type: String
    },
    region: {
        type: String
    },
    phone_number: {
        type: String
    },
    email: {
        type: String,
        required: true,
    },
    password: {
        type: String
    },
    fav_icon: {
        type: String
    },
    logo: {
        type: String
    },
    profile: {
        type: String
    },
    opening_time: {
        type: String,
        default : ""
    },
    closing_time: {
        type: String,
        default : ""
    },
    duration: {
        type: Number,
        default : null
    },
    automatic_booking: {
        type: Number,
        default:1
    },
    account_holder: {
        type: String
    },
    bank_name: {
        type: String
    },
    account_number: {
        type: String
    },
    branch_name: {
        type: String
    },
    language: {
        type: String
    },
    finalclient_count : {
        type: Number,
        default :0
    },
    employee_count : {
        type: Number,
        default :0
    },
    subscription : {
        type: Number,
        default :0
    },
    subscription_end: {
        type : String,
        default: "0"
    },    
    total_booking: {
        type : Number,
        default: 0
    },
    status:{
        type:Number,
        default:0
    }, 
    // 0 - disable , 1 - active, 2 - deleted , 3 - subscription pending
    created_at: {
        type: String
    },
    requirements: {
        type : [String],
        default : []
    }
});

module.exports = mongoose.model("User", UsersSchema);

