const express = require("express");
const router = express.Router();

let adminController = require("../controllers/adminController");

router.get("/dashboard", adminController.dashboard);

router.get("/businessowner/:status", adminController.accounts);
router.get("/businessowner/:id", adminController.getaccount);
router.post("/businessowner/create", adminController.accountCreate);
router.post("/businessowner/edit", adminController.accountEdit);

router.get("/help/", adminController.helps);
router.get("/help/:id", adminController.gethelp);
router.post("/help/create", adminController.helpCreate);
router.post("/help/edit", adminController.helpEdit);

router.get("/reservation/", adminController.reservations);
router.get("/reservation/:id", adminController.getreservation);

router.get("/transaction/", adminController.transactions);
router.get("/transaction/:id", adminController.gettransaction);

router.get("/commonsetting/", adminController.commonSettings);
router.post("/commonsetting/edit", adminController.commonUpdate);

/** Update_140525 */
// router.get("/appdefaults", adminController.appDefaults);

module.exports = router;