const express = require("express");
const router = express.Router();
let businessownerController = require("../controllers/businessownerController");
let subscriptionController = require("../controllers/subscriptionController");
let finalclientController = require("../controllers/finalclientController");
let chatController = require("../controllers/chatController");

router.get("/:companyname", businessownerController.index);
router.post("/:companyname/login", businessownerController.login);
router.post("/:companyname/profile", businessownerController.profile);

router.post("/:companyname/subscriptionpayment", subscriptionController.subscriptionPayment);
router.post("/subscriptionwebhook", subscriptionController.subscriptionWebhook); // Refer index.js
router.post("/:companyname/allSubscriptions", subscriptionController.allSubscriptions);

router.post("/:companyname/addfinalclient", businessownerController.addFinalclient);
router.get("/:companyname/getrequirements", businessownerController.getRequirements);
router.post("/:companyname/addrequirements", businessownerController.addRequirements);
router.get("/:companyname/getfinalclients", businessownerController.manageFinalclients);

router.post("/:companyname/addemployee", businessownerController.addEmployee);
router.get("/:companyname/getemployees", businessownerController.exployees);
router.put("/:companyname/editemployee", businessownerController.editEmployee);
router.put("/:companyname/deleteemployee/", businessownerController.removeEmployee);
router.post("/:companyname/addabsence", businessownerController.addabsence);
router.get("/:companyname/getabsence", businessownerController.getAbsencelog);

router.post("/:companyname/getbookings", businessownerController.allBookings);
router.post("/:companyname/changebookingstatus", businessownerController.changeBookingstatus);


/** Update_200525 */
router.post("/:companyname/createchat", chatController.createChat);
router.post("/:companyname/getchat", chatController.getChat);
router.post("/:companyname/getchathistory", chatController.getChatHistory);

module.exports = router;
