const fs = require("fs");
const express = require("express");
const moment = require("moment");
const app = express();
const mongoose = require("mongoose");

const SettingModel = require("../models/Settings");
const UserModel = require("../models/Users");
const FinalclientModel = require("../models/Users");
const ChatModel = require("../models/Chats");
const MessageModel = require("../models/Messages");

let server = require("http").createServer(app);

const io = require("socket.io")(server, {
  cors: {
    origin: "http://68.183.80.168",
    methods: ["GET", "POST"],
    credentials: true
  }
});

mongoose.connect('mongodb://root:ServiceHT52023@143.244.140.29:24423/pwa?authSource=admin').then(() => {
    // console.log("Database Connected Successfully");
    
    io.on('connection', (socket) => {
        // console.log('Client connected');

        socket.on("joinRoom", function (data) {
            socket.join(data.roomId);
            console.log(`${data.userId} joined room: ${data.roomId}`);
        });

        socket.on("typing", function (data) {
            socket.to(data.roomId).emit('typing', data);
        });

        socket.on("sendMessage", function (data) {
            if (data.type === "text") {
                let newMessage = new MessageModel({
                    userId: data.userId,
                    chatId: data.chatId,
                    roomId: data.roomId,
                    message: data.message,
                    type: data.type
                });
                newMessage.save().then(async (messageDetails) => {
                    if (messageDetails) {
                        ChatModel.findOneAndUpdate({roomId: data.roomId}, { 
                            lastMessage: data.message, 
                            lastMessageOn: moment().toISOString() 
                        }).then(() => {
                            socket.to(data.roomId).emit('receiveMessage', data);
                        }).catch((error) => {
                            console.log("Err: ", error);
                        });
                    }
                }).catch((error) => {
                    console.log("Err: ", error);
                });
            }
        });
    });

    server.listen(3001, () => {
        console.log('Socket.io is running at http://68.183.80.168:3001');
    });
}).catch((err) => {
    console.log("MongoDB connection error: ", err);
});